Index: trunk/LMDZ.VENUS/libf/phyvenus/physiq_mod.F
===================================================================
--- trunk/LMDZ.VENUS/libf/phyvenus/physiq_mod.F	(revision 2463)
+++ trunk/LMDZ.VENUS/libf/phyvenus/physiq_mod.F	(revision 2464)
@@ -69,4 +69,5 @@
       USE chemparam_mod
       USE conc
+      USE param_v4_h
       USE compo_hedin83_mod2
 !      use ieee_arithmetic
@@ -257,5 +258,4 @@
       EXTERNAL nlthermeq
       EXTERNAL euvheat
-      EXTERNAL param_read
       EXTERNAL param_read_e107
       EXTERNAL conduction
@@ -356,4 +356,5 @@
 c
       REAL :: tr_seri(klon,klev,nqmax)
+      REAL :: tr_hedin(klon,klev,nqmax)
       REAL :: d_tr(klon,klev,nqmax)
 
@@ -411,6 +412,7 @@
 
 c======================================================================
+c======================================================================
 c INITIALISATIONS
-c================
+c======================================================================
 
       modname = 'physiq'
@@ -437,4 +439,5 @@
       END IF 
       
+c======================================================================
 c PREMIER APPEL SEULEMENT
 c========================
@@ -584,6 +587,7 @@
 
          if (callthermos) then
-            if(solvarmod.eq.0) call param_read
-            if(solvarmod.eq.1) call param_read_e107 
+            call fill_data_thermos
+            call allocate_param_thermos(klev)
+            call param_read_e107 
          endif
 
@@ -597,5 +601,4 @@
             rho(ig,j)=pplay(ig,j)*mmean(ig,j)*1e-3/(rnew(ig,j)*t(ig,j))
           enddo
-c        stop
 
         enddo  
@@ -749,9 +752,12 @@
 
       if(callthermos) then
-         call concentrations2(pplay,t,d_t,qx,nqmax)
+         call concentrations2(pplay,t,qx,nqmax)
       endif
 
+c========================
       ENDIF ! debut
-
+c========================
+
+c======================================================================
 ! ------------------------------------------------------
 !   Initializations done at every physical timestep:
@@ -923,5 +929,5 @@
 c====================================================================
 c Orbite et eclairement
-c====================================================================
+c=======================
 
 c Pour VENUS, on fixe l'obliquite a 0 et l'eccentricite a 0.
@@ -931,5 +937,5 @@
       
       zlongi = 0.0
-      dist   = 0.72  ! en UA
+      dist   = 0.72333  ! en UA
 
 c Si on veut remettre l'obliquite a 3 degres et/ou l'eccentricite 
@@ -952,8 +958,58 @@
       end if
 
+c======================================================================
+c FIN INITIALISATIONS
+c======================================================================
+c======================================================================
+
+c=======================================================
+! CONDUCTION  and  MOLECULAR VISCOSITY
+c=======================================================
+
+        d_t_conduc(:,:)=0.
+        d_u_molvis(:,:)=0.
+        d_v_molvis(:,:)=0.
+
+        IF (callthermos) THEN
+
+           tsurf(:)=t_seri(:,1)
+           call conduction(klon, klev,pdtphys,
+     $            pplay,paprs,t_seri,
+     $            tsurf,zzlev,zzlay,d_t_conduc)
+
+            call molvis(klon, klev,pdtphys,
+     $            pplay,paprs,t_seri,
+     $            u,tsurf,zzlev,zzlay,d_u_molvis)
+
+            call molvis(klon, klev, pdtphys,
+     $            pplay,paprs,t_seri,
+     $            v,tsurf,zzlev,zzlay,d_v_molvis)
+
+            DO k=1,klev
+               DO ig=1,klon
+                   t_seri(ig,k)= t_seri(ig,k)+ d_t_conduc(ig,k)*dtime ! [K]
+                   u_seri(ig,k)= u_seri(ig,k)+ d_u_molvis(ig,k)*dtime ! m/s
+                   v_seri(ig,k)= v_seri(ig,k)+ d_v_molvis(ig,k)*dtime ! m/s
+               ENDDO
+            ENDDO
+        ENDIF
+
+c====================================================================
+c    Compute mean mass, cp and R :
+c------------------------------------
+
+      if(callthermos) then
+         call concentrations2(pplay,t_seri,tr_seri, nqmax)
+      endif
+
+
+c=======================================================
+! CHEMISTRY AND MICROPHYSICS
+c=======================================================
+
       if (iflag_trac.eq.1) then
 !====================================================================
 ! Case 1: pseudo-chemistry with relaxation toward fixed profile
-!====================================================================
+!=========
        if (tr_scheme.eq.1) then
 
@@ -968,8 +1024,7 @@
 ! However, the variable 'source' could be used in physiq
 ! so the call to phytrac_emiss could be to initialise it.
-!====================================================================
-
-         call phytrac_emiss ( (rjourvrai+gmtime)*RDAY,
-     I                   debut,lafin,nqmax,
+!=========
+
+         call phytrac_emiss (debut,lafin,nqmax,
      I                   nlon,nlev,dtime,paprs,
      I                   latitude_deg,longitude_deg,
@@ -985,5 +1040,5 @@
 !         nbapp_chem = 24000 => chempas = 4 => zctime = 420 s
 !         nbapp_chem = 12000 => chempas = 8 => zctime = 840 s
-!====================================================================
+!=========
 
          nbapp_chem = 24000
@@ -1131,6 +1186,6 @@
 
             do iq = 1, nqmax - nmicro
-               tr_seri(:,:,iq) = tr_seri(:,:,iq) 
-     $                         + d_tr_chem(:,:,iq)*zctime
+               tr_seri(:,:,iq) = max(tr_seri(:,:,iq) 
+     $                         + d_tr_chem(:,:,iq)*zctime,1.e-30)
             end do
 
@@ -1144,6 +1199,6 @@
             else if (cl_scheme == 2) then
                do iq = nqmax-nmicro+1,nqmax
-                  tr_seri(:,:,iq) = tr_seri(:,:,iq) 
-     $                            + d_tr_sed(:,:,iq)*zctime
+                  tr_seri(:,:,iq) = max(tr_seri(:,:,iq) 
+     $                            + d_tr_sed(:,:,iq)*zctime,1.e-30)
                end do
             end if  ! cl_scheme
@@ -1152,5 +1207,5 @@
          end if     ! mod(itap,chempas)  <------- end of chemistry supercycling
 
-!====================================================================
+!=========
 ! End Case 3: Full chemistry and/or clouds.
 !====================================================================
@@ -1300,7 +1355,4 @@
 !      call writefield_phy('physiq_d_ts',d_ts,1)
 
-c
-c Appeler l'ajustement sec
-c
 c===================================================================
 c Convection seche 
@@ -1371,12 +1423,4 @@
       END IF 
 
-c------------------------------------
-c    Compute mean mass, cp and R :
-c------------------------------------
-
-      if(callthermos) then
-         call concentrations2(pplay,t_seri,d_t,tr_seri, nqmax)
-      endif
-
 c====================================================================
 c RAYONNEMENT
@@ -1385,6 +1429,15 @@
 
       dtimerad = dtime*REAL(radpas)  ! pas de temps du rayonnement (s)
-c====================================================================
-
+
+! update mmean
+         if (ok_chem) then
+            mmean(:,:) = 0.
+            do iq = 1,nqmax - nmicro
+               mmean(:,:) = mmean(:,:)+tr_seri(:,:,iq)*m_tr(iq)
+               rnew(:,:) = 8.314/mmean(:,:)*1.e3     ! J/kg K 
+            enddo
+         endif
+
+cc---------------------------------------------
       if (callnlte .or. callthermos) then
          if (ok_chem) then
@@ -1411,7 +1464,15 @@
         IF(callnlte) THEN                                 
             if(nltemodel.eq.0.or.nltemodel.eq.1) then
-                CALL nltecool(klon, klev, nqmax, pplay*9.869e-6, t_seri,
-     $                    tr_seri, d_t_nlte)
+c nltecool call not correct...
+c                CALL nltecool(klon, klev, nqmax, pplay*9.869e-6, t_seri,
+c     $                    tr_seri, d_t_nlte)
+                abort_message='nltemodel=0 or 1 should not be used...'
+                call abort_physic(modname,abort_message,1)
             else if(nltemodel.eq.2) then                                
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!! HEDIN instead of compo for this calculation
+!              call compo_hedin83_mod(pplay,rmu0,   
+!    $                 co2vmr_gcm,covmr_gcm,ovmr_gcm,n2vmr_gcm,nvmr_gcm)     
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
                CALL nlte_tcool(klon,klev,pplay*9.869e-6,              
      $               t_seri,zzlay,co2vmr_gcm, n2vmr_gcm, covmr_gcm, 
@@ -1436,5 +1497,5 @@
      $        CALL nlthermeq(klon, klev, paprs, pplay) 
 
-c
+cc---------------------------------------------
 c       LTE radiative transfert / solar / IR matrix
 c       ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
@@ -1455,4 +1516,5 @@
 c       heat(:,:)=heat(:,:)/(1.+0.80*((rjourvrai-356)+gmtime)/20.)
 
+cc---------------------------------------------
 c       CO2 near infrared absorption
 c      ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
@@ -1460,9 +1522,23 @@
         d_t_nirco2(:,:)=0.
         if (callnirco2) then
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!! HEDIN instead of compo for this calculation
+!          call compo_hedin83_mod(pplay,rmu0,   
+!    $                 co2vmr_gcm,covmr_gcm,ovmr_gcm,n2vmr_gcm,nvmr_gcm)
+!          tr_hedin(:,:,:)=tr_seri(:,:,:)
+!          tr_hedin(:,:,i_co2)=co2vmr_gcm(:,:)/mmean(:,:)*m_tr(i_co2)
+!          tr_hedin(:,:,i_co) = covmr_gcm(:,:)/mmean(:,:)*m_tr(i_co)
+!          tr_hedin(:,:,i_o)  =  ovmr_gcm(:,:)/mmean(:,:)*m_tr(i_o)
+!          tr_hedin(:,:,i_n2) = n2vmr_gcm(:,:)/mmean(:,:)*m_tr(i_n2)
+!          call nirco2abs (klon, klev, pplay, dist, nqmax, tr_hedin,
+!    .                 rmu0, fract, d_t_nirco2)
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            call nirco2abs (klon, klev, pplay, dist, nqmax, tr_seri,
      .                 rmu0, fract, d_t_nirco2)
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
         endif
 
 
+cc---------------------------------------------
 c          Net atmospheric radiative heating rate (K.s-1)
 c          ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
@@ -1484,5 +1560,4 @@
 
 cc---------------------------------------------
-
 c          EUV heating rate (K.s-1)
 c          ~~~~~~~~~~~~~~~~~~~~~~~~
@@ -1492,10 +1567,13 @@
         IF (callthermos) THEN
 
-c           call euvheat(klon, klev,t_seri,paprs,pplay,zzlay,
-c     $          rmu0,pdtphys,gmtime,rjourvrai, co2vmr_gcm, n2vmr_gcm, 
-c     $          covmr_gcm, ovmr_gcm,d_t_euv )
            call euvheat(klon, klev, nqmax, t_seri,paprs,pplay,zzlay,
-     $         rmu0,dtimerad,gmtime,rjourvrai,
+     $         rmu0,dtimerad,gmtime,
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!! HEDIN instead of compo for this calculation
+!! cf nlte_tcool and nirco2abs above !!
+!    $         tr_hedin, d_tr, d_t_euv )
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      $         tr_seri, d_tr, d_t_euv )
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
                  
            DO k=1,klev
@@ -1508,5 +1586,4 @@
         ENDIF  ! callthermos
 
-c====================================================================
       ENDIF    ! radpas
 c====================================================================
@@ -1523,38 +1600,10 @@
 
       itap   = itap + 1
-
-! CONDUCTION  and  MOLECULAR VISCOSITY
-c ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-
-        d_t_conduc(:,:)=0.
-        d_u_molvis(:,:)=0.
-        d_v_molvis(:,:)=0.
-
-        IF (callthermos) THEN
-
-           tsurf(:)=t_seri(:,1)
-           call conduction(klon, klev,pdtphys,
-     $            pplay,paprs,t_seri,
-     $            tsurf,zzlev,zzlay,d_t_conduc)
-
-            call molvis(klon, klev,pdtphys,
-     $            pplay,paprs,t_seri,
-     $            u,tsurf,zzlev,zzlay,d_u_molvis)
-
-            call molvis(klon, klev, pdtphys,
-     $            pplay,paprs,t_seri,
-     $            v,tsurf,zzlev,zzlay,d_v_molvis)
-
-            DO k=1,klev
-               DO ig=1,klon
-                  t_seri(ig,k)= t_seri(ig,k)+ d_t_conduc(ig,k)*dtime ! [K]
-                  u_seri(ig,k)= u_seri(ig,k)+ d_u_molvis(ig,k)*dtime ! m/s
-                  v_seri(ig,k)= v_seri(ig,k)+ d_v_molvis(ig,k)*dtime ! m/s
-               ENDDO
-            ENDDO
-        ENDIF
-
-
+c====================================================================
+
+
+c==============================
 !  --  MOLECULAR DIFFUSION ---
+c==============================
 
           d_q_moldif(:,:,:)=0
@@ -1564,5 +1613,5 @@
              call moldiff_red(klon, klev, nqmax,
      &                   pplay,paprs,t_seri, tr_seri, pdtphys,
-     &                   zzlay,d_t_euv,d_t_conduc,d_q_moldif)
+     &                   d_t_euv,d_t_conduc,d_q_moldif)
 
 
@@ -1572,11 +1621,10 @@
            DO k=1,klev
               DO ig=1,klon
-                tr_seri(ig,k,iq)= tr_seri(ig,k,iq)+ 
-     &                           d_q_moldif(ig,k,iq)*dtime ! [Kg/kg]?
+                tr_seri(ig,k,iq)= max(tr_seri(ig,k,iq)+ 
+     &                           d_q_moldif(ig,k,iq)*dtime,1.e-30)
               ENDDO
             ENDDO
            ENDDO
            
-
          ENDIF  ! callthermos & ok_chem
 
@@ -1878,4 +1926,9 @@
       ENDDO
       
+c mise à jour rho,mmean pour sorties
+      if(callthermos) then
+         call concentrations2(pplay,t_seri,tr_seri, nqmax)
+      endif
+
 c------------------------
 c Calcul moment cinetique
@@ -2005,5 +2058,5 @@
          do iq = 1,nqmax - nmicro
             call send_xios_field(tname(iq),
-     $                           qx(:,:,iq)*mmean(:,:)/m_tr(iq))
+     $                           tr_seri(:,:,iq)*mmean(:,:)/m_tr(iq))
          end do
 
@@ -2012,7 +2065,7 @@
          if ((tr_scheme == 3) .and. (cl_scheme == 1)) THEN
             call send_xios_field(tname(i_h2oliq),
-     $             qx(:,:,i_h2oliq)*mmean(:,:)/m_tr(i_h2oliq))
+     $             tr_seri(:,:,i_h2oliq)*mmean(:,:)/m_tr(i_h2oliq))
             call send_xios_field(tname(i_h2so4liq),
-     $             qx(:,:,i_h2so4liq)*mmean(:,:)/m_tr(i_h2so4liq))
+     $             tr_seri(:,:,i_h2so4liq)*mmean(:,:)/m_tr(i_h2so4liq))
             if (ok_sedim) then
                call send_xios_field("Fsedim",fsedim(:,1:klev))
@@ -2022,5 +2075,5 @@
 ! chemical iterations
 
-         call send_xios_field("iter",real(iter))
+         if (tr_scheme.eq.3) call send_xios_field("iter",real(iter))
 
       end if
@@ -2031,4 +2084,8 @@
        CALL send_xios_field("d_qmoldifN2",d_q_moldif(:,:,i_n2))
       ENDIF
+
+!! DEBUG
+!      if (is_master) print*,"itauphy=",itap
+!      if (itap.eq.10) lafin=.true.
 
       if (lafin.and.is_omp_master) then
Index: trunk/LMDZ.VENUS/libf/phyvenus/phytrac_chimie.F
===================================================================
--- trunk/LMDZ.VENUS/libf/phyvenus/phytrac_chimie.F	(revision 2463)
+++ trunk/LMDZ.VENUS/libf/phyvenus/phytrac_chimie.F	(revision 2464)
@@ -15,5 +15,5 @@
 
       use chemparam_mod
-      use conc, only: mmean
+      use conc, only: mmean,rnew
 
       implicit none
@@ -73,4 +73,5 @@
          if (reinit_trac .and. ok_chem) then
 
+!!! in this reinitialisation, trac is VOLUME mixing ratio
             print*, "Tracers are re-initialised"
             trac(:,:,:) = 1.0e-30
@@ -106,6 +107,13 @@
             end if
         
+
+! update mmean
+            mmean(:,:) = 0.
+            do iq = 1,nqmax - nmicro
+               mmean(:,:) = mmean(:,:)+trac(:,:,iq)*m_tr(iq)
+               rnew(:,:) = 8.314/mmean(:,:)*1.e3     ! J/kg K 
+            enddo
+
 !           convert volume to mass mixing ratio
-
             do iq = 1,nqmax - nmicro
                trac(:,:,iq) = trac(:,:,iq)*m_tr(iq)/mmean(:,:)
@@ -269,4 +277,11 @@
 !===================================================================
 
+! update mmean
+            mmean(:,:) = 0.
+            do iq = 1,nqmax - nmicro
+               mmean(:,:) = mmean(:,:)+trac(:,:,iq)*m_tr(iq)
+               rnew(:,:) = 8.314/mmean(:,:)*1.e3     ! J/kg K 
+            enddo
+
 !     gas phase
 
Index: trunk/LMDZ.VENUS/libf/phyvenus/phytrac_emiss.F
===================================================================
--- trunk/LMDZ.VENUS/libf/phyvenus/phytrac_emiss.F	(revision 2463)
+++ trunk/LMDZ.VENUS/libf/phyvenus/phytrac_emiss.F	(revision 2464)
@@ -4,14 +4,15 @@
 c
 c
-      SUBROUTINE phytrac_emiss (timesimu,
-     I                    debutphy,
+      SUBROUTINE phytrac_emiss (debutphy,
      I                    lafin,
      I                    nqmax,
      I                    nlon,
-     I                    nlev, 
+     I                    nlev,
      I                    pdtphys,
-     I                    paprs,
+     I                    paprs, 
      I                    xlat,xlon,
      O                    tr_seri)
+     
+     
 
 c======================================================================
@@ -28,5 +29,8 @@
 c
 c======================================================================
-      USE infotrac_phy, ONLY: nqtot
+      use infotrac_phy, only: tname, nqtot
+#ifdef CPP_XIOS      
+      use xios_output_mod, only:  send_xios_field
+#endif
       use dimphy
       USE geometry_mod, only: cell_area
@@ -36,4 +40,5 @@
 #include "YOMCST.h"
 #include "clesphys.h"
+     
 c======================================================================
 
@@ -43,5 +48,4 @@
 c   ==========
 
-      real timesimu   ! duree depuis debut simu (s)
       logical debutphy       ! le flag de l'initialisation de la physique
       logical lafin          ! le flag de la fin de la physique
@@ -63,21 +67,29 @@
 cAA ----------------------------
 
-c pour emission volcan
+c pour emission type effusion
       real :: deltatr(klon,klev,nqtot)
 
-      integer,parameter :: nblat=5,nblon=4,nbz=3
-      integer,parameter :: Nemiss=0     ! duree emission (Ed)
-      integer,save :: Nheight(nbz)      ! layer emission
-      real,save :: so2_quantity         ! quantity so2 (kg)
-      real,save :: lat_volcan(nblat),lon_volcan(nblon)
-      real,save :: area_emiss(nblat,nblon)
-      integer,save :: ig_volcan(nblat,nblon)
+
+
+
+      integer,parameter :: nblat=3,nblon=3,nbaire=3,nbflux=2,maxcell=16 
+      integer,parameter :: Nheight=3 ! layer emission (150m)
+      integer,save :: Ncell(nbaire) 
+      real,save :: flux_surface_co2(nbflux) ! flux de CO2 emis (kg/m2/s) 
+      real :: flux(nlon,nqtot) 
+      real,save :: lat_zone(nblat),lon_zone(nblon) 
+      integer,save :: ig_zone(nblat,nblon,nbaire,nbflux,maxcell) 
+      integer,save :: numcell(nblat,nblon,nbaire,nbflux)
+        
 
       INTEGER i, k, it
-      integer ilat,ilon,iz
+      integer ilat,ilon,iaire,iflux,ipos
       real    deltalat,deltalon
-c======================================================================
-
-c EMISSION TRACEURS 
+      
+
+
+c======================================================================
+
+c EMISSIONS TRACEURS 
 
 c---------
@@ -90,6 +102,6 @@
 
         ALLOCATE(M_tr(nqtot))
-        M_tr(:)=64.                 ! SO2
-	
+        M_tr(:)=44.                ! CO2
+
 C=========================================================================
 c Caracteristiques des traceurs emis:
@@ -97,30 +109,33 @@
 
 c nombre total de traceur
-         if (nbz*nblat*nblon .gt. nqtot) then
-            print*, nbz*nblat*nblon, nqtot
+         if (nblat*nblon*nbaire*nbflux+1 .gt. nqtot) then
+            print*, nblat*nblon*nbaire*nbflux+1, nqtot
             write(*,*) "Attention, pas assez de traceurs"
             write(*,*) "le dernier sera bien le dernier"
-         endif
-
-c quantite en kg
-         so2_quantity = 20.*10.**9.
-
-c height (in layer index)
-         Nheight(1) =  6  ! ~ 1 km
-         Nheight(2) = 16  ! ~ 25 km
-         Nheight(3) = 24  ! ~ 50 km
-
-c localisation volcan
-         lat_volcan(1) =  70.
-         lat_volcan(2) =  35.
-         lat_volcan(3) =   0.
-         lat_volcan(4) = -35.
-         lat_volcan(5) = -70.
-         lon_volcan(1) = -125.
-         lon_volcan(2) =  -35.
-         lon_volcan(3) =   55.
-         lon_volcan(4) =  145.
-	 
-	 ig_volcan(ilat,ilon)= 0
+         endif 
+                 
+
+
+
+c flux de CO2 (kg/s/m2)
+         flux_surface_co2(1) = 5.*10.**-9.
+         flux_surface_co2(2) = 5.*10.**-15.
+
+c nombre de cellule pour le cote du carre d'aire 
+         Ncell(1)= 2
+         Ncell(2)= 3
+         Ncell(3)= 4
+      
+
+
+c localisation zone emission
+         lat_zone(1) = 08.
+         lat_zone(2) = -50.
+         lat_zone(3) = 35.
+         lon_zone(1) = -172.
+         lon_zone(2) = -20.
+         lon_zone(3) = 70.
+
+ 
          if ((nbp_lon*nbp_lat)==1) then ! running a 1D simulation
            deltalat=180.
@@ -131,15 +146,28 @@
          endif
 
+         numcell(:,:,:,:)=0
+         ig_zone(:,:,:,:,:)=0
          do i=1,nlon
           do ilat=1,nblat
            do ilon=1,nblon
-            if ((xlat(i).ge.lat_volcan(ilat))
-     &     .and.((xlat(i)-deltalat).lt.lat_volcan(ilat))
-     &     .and.(xlon(i).le.lon_volcan(ilon))
-     &     .and.((xlon(i)+deltalon).gt.lon_volcan(ilon)) ) then
-             ig_volcan(ilat,ilon)= i
-             area_emiss(ilat,ilon) = cell_area(i)
-	     print*,"Lat,lon=",ilat,ilon," OK"
-            end if
+            do iaire=1,nbaire
+
+             if ((xlat(i).ge.lat_zone(ilat))
+     &      .and.((xlat(i)-Ncell(iaire)*deltalat)
+     &      .lt.lat_zone(ilat))
+     &      .and.(xlon(i).le.lon_zone(ilon))
+     &      .and.((xlon(i)+Ncell(iaire)*deltalon)
+     &      .gt.lon_zone(ilon))) then
+
+              do iflux=1,nbflux
+         numcell(ilat,ilon,iaire,iflux)=numcell(ilat,ilon,iaire,iflux)+1
+        ig_zone(ilat,ilon,iaire,iflux,numcell(ilat,ilon,iaire,iflux))= i
+             print*,"Lat,lon,naire,nflux,nlon=",ilat,ilon,iaire,iflux
+     &        ,i," OK"
+              end do
+
+             end if
+
+            end do
            end do
           end do
@@ -148,16 +176,15 @@
 c Reinit des traceurs si necessaire
          if (reinit_trac) then
-	   tr_seri(:,:,:)=0.
-c CAS N2 TRACEUR PASSIF POUR EVALUER PROFIL SOUS 7 KM
-c J'ai mis Nemiss=0 !
+          tr_seri(:,:,:)=0.
+
+
            do i=1,klon
             do k=1,klev
-              tr_seri(i,k,:)=max(min(0.035,
-     &          0.035*(1.-log(paprs(i,k)/6.e6)/log(9.e6/6.e6))),0.)
-            enddo
-           enddo
-c FIN CAS N2 PASSIF
-	 endif
-	 
+              tr_seri(i,k,:)=1.-28/43.44*max(min(0.035,
+     &           0.035*(1.-log(paprs(i,k)/6.e6)/log(9.e6/6.e6))),0.)
+            end do
+           end do
+         endif
+ 
 C=========================================================================
 C=========================================================================
@@ -168,22 +195,21 @@
 
 c======================================================================
-c Emission d'un traceur pendant un certain temps
+c Emission continue d'un traceur
 c necessite raz_date=1 dans run.def
 c et reinit_trac=y
 c======================================================================
        deltatr(:,:,:) = 0.
-
-c source appliquee pendant Nemiss Ed
-       if (timesimu .lt. 86400*Nemiss) then
+       flux(:,:)=0.
 
 c emet les traceurs qui sont presents sur la grille
-        do ilat  = 1,nblat
-        do ilon  = 1,nblon
-         if (ig_volcan(ilat,ilon).ne.0) then
-	 
-          do iz = 1,nbz
-           it=min( (iz-1)*nblat*nblon+(ilat-1)*nblon+ilon , nqtot )	    
-           i=ig_volcan(ilat,ilon)
-	   
+      do ilat  = 1,nblat
+       do ilon  = 1,nblon
+        do iaire = 1,nbaire
+         do iflux = 1,nbflux
+     
+              it=min( (ilat-1)*nblon*nbflux*nbaire+(iaire-1)*nbflux
+     &         +(ilon-1)*nbaire*nbflux+iflux , nqtot )   
+ 
+
 c injection dans une seule cellule:
 c source en kg/kg/s
@@ -196,22 +222,42 @@
 
 c injection dans toute la colonne (a faire):
-            do k=1,Nheight(iz)
-             deltatr(i,k,it) = so2_quantity/(86400.*Nemiss) ! kg/s
-     $  *RG/( area_emiss(ilat,ilon)
-     $       *(paprs(i,1)-paprs(i,Nheight(iz)+1)) )    ! /kg (masse colonne)
-     
-             tr_seri(i,k,it) = tr_seri(i,k,it)+deltatr(i,k,it)*pdtphys
-	    end do
-	    
+          do ipos=1,maxcell
+ 
+           if (ig_zone(ilat,ilon,iaire,iflux,ipos).ne.0) then
+
+             i=ig_zone(ilat,ilon,iaire,iflux,ipos)         
+             flux(i,it)=flux_surface_co2(iflux)  
+              
+            do k=1,Nheight
+             deltatr(i,k,it) = flux_surface_co2(iflux) ! kg/s/m2
+     $         *RG/(paprs(i,1)-paprs(i,Nheight+1))    ! /kg (masse colonne)
+     
+               tr_seri(i,k,it) = tr_seri(i,k,it)+deltatr(i,k,it)*pdtphys
+            end do
+
+           end if 
           end do
-	  
-         endif  ! ig_volcan!=0
-        end do
-        end do
-
-       end if  ! duree emission
+ 
+        end do
+        end do
+        end do
+        end do
+
        
 c======================================================================
 c======================================================================
+
+   
+      
+
+     
+#ifdef CPP_XIOS      
+       do it=1,nqtot
+       CALL  send_xios_field("flux_"//tname(it),
+     &                     flux(:,it)) 
+      end do 
+#endif
+
+
 
       RETURN
Index: trunk/LMDZ.VENUS/libf/phyvenus/sw_venus_rh.F
===================================================================
--- trunk/LMDZ.VENUS/libf/phyvenus/sw_venus_rh.F	(revision 2463)
+++ trunk/LMDZ.VENUS/libf/phyvenus/sw_venus_rh.F	(revision 2464)
@@ -285,10 +285,32 @@
 c         PHEAT(j) = PHEAT(j)*2.
 c        endif
-        if ((PPB(j).gt.1.4).and.(PPB(j).le.10.)) then
+c BASE:
+c        if ((PPB(j).gt.1.4).and.(PPB(j).le.10.)) then
+c          PHEAT(j) = PHEAT(j)*3
+c        endif
+c AFTER Tayloring TdeepD
+         if ((PPB(j).gt.1.4).and.(PPB(j).le.10.)) then
+           PHEAT(j) = PHEAT(j)*3.5
+         endif
+         if ((PPB(j).gt.10.).and.(PPB(j).le.50.)) then
+           PHEAT(j) = PHEAT(j)*1.5
+         endif
+c Options:
+c        if ((PPB(j).gt.1.4).and.(PPB(j).le.10.)) then
+c        if ((PPB(j).gt.2.0).and.(PPB(j).le.10.)) then
 c        if ((PPB(j).gt.1.4).and.(PPB(j).le.100.)) then
-         PHEAT(j) = PHEAT(j)*3
-        endif
-c        if ((PPB(j).gt.10.).and.(PPB(j).le.120.)) then
-c         PHEAT(j) = PHEAT(j)*2
+c          PHEAT(j) = PHEAT(j)*3.5
+c          PHEAT(j) = PHEAT(j)*3
+c          PHEAT(j) = PHEAT(j)*2.5
+c        endif
+c        if ((PPB(j).gt.10.).and.(PPB(j).le.35.)) then
+c        if ((PPB(j).gt.10.).and.(PPB(j).le.50.)) then
+c          PHEAT(j) = PHEAT(j)*2
+c          PHEAT(j) = PHEAT(j)*1.5
+c          PHEAT(j) = PHEAT(j)*1.3
+c        endif
+c        if ((PPB(j).gt.35.).and.(PPB(j).le.120.)) then
+c          PHEAT(j) = PHEAT(j)*2
+c          PHEAT(j) = PHEAT(j)*1.5
 c        endif
 c----------------
